Index: issm/branches/trunk-jpl-damage/src/m/model/plot/plot_gridded.m
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/model/plot/plot_gridded.m	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/m/model/plot/plot_gridded.m	(revision 12878)
@@ -6,6 +6,4 @@
 %
 %   See also: PLOTMODEL
-
-whitepos=getfieldvalue(options,'whitepos',2); %1: up, 2: down, else: none
 
 %process mesh and data
@@ -29,4 +27,10 @@
 end
 
+%Get and change colormap
+map    = getcolormap(options);
+lenmap = size(map,1);
+map    = [1 1 1; map];
+options=changefieldvalue(options,'colormap',map);
+
 %Process data_grid: add white in NaN and correct caxis accordingly
 if exist(options,'caxis'),
@@ -40,27 +44,14 @@
 	data_max=max(data_grid(:));
 end
-options=changefieldvalue(options,'cbYLim',[data_min data_max]);
-if whitepos==1,
-	white  =data_max + (data_max-data_min)/55;
-	options=changefieldvalue(options,'caxis',[data_min white]);
-	data_grid(isnan(data_grid))=white;
-elseif whitepos==2,
-	white  =data_min - (data_max-data_min)/55;
-	options=changefieldvalue(options,'caxis',[white data_max]);
-	data_grid(isnan(data_grid))=white;
-end
+options = changefieldvalue(options,'cbYLim',[data_min data_max]);
+white   = data_min - (data_max-data_min)/(lenmap);
+options = changefieldvalue(options,'caxis',[white data_max]);
+data_grid(isnan(data_grid))=white;
 
 %Select plot area 
-subplot(plotlines,plotcols,i);
+subplotmodel(plotlines,plotcols,i,options);
 
 %shading interp;
 h=imagesc(xlim,ylim,data_grid);set(gca,'YDir','normal');
-map=getfieldvalue(options,'colormap',jet);
-if whitepos==1,
-	map(end,:)=[1 1 1];
-elseif whitepos==2,
-	map(1,:)=[1 1 1];
-end
-options=changefieldvalue(options,'colormap',map);
 
 %last step: mesh gridded?
Index: issm/branches/trunk-jpl-damage/src/m/model/plot/plot_manager.m
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/model/plot/plot_manager.m	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/m/model/plot/plot_manager.m	(revision 12878)
@@ -165,4 +165,10 @@
 if exist(options,'sectionvalue')
 	plot_section(md,data,options,nlines,ncols,i);
+	return;
+end
+
+%Figure out if this is a Profile plot
+if exist(options,'profile')
+	plot_profile(md,data,options,nlines,ncols,i);
 	return;
 end
Index: issm/branches/trunk-jpl-damage/src/m/model/plot/plot_overlay.m
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/model/plot/plot_overlay.m	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/m/model/plot/plot_overlay.m	(revision 12878)
@@ -41,4 +41,8 @@
 	md=radarpower(md,options);
 end
+contrast = getfieldvalue(options,'contrast',1);  
+radar = (md.radaroverlay.pwr).^(contrast);
+radar = radar./max(radar(:));
+%radar(find(radar==0))=1; %Change background from black to white
 
 %InterpFromMeshToGrid
@@ -50,8 +54,14 @@
 ncols =length(md.radaroverlay.x);
 disp('Interpolating data on grid...');
-[x_m y_m data_grid]=InterpFromMeshToGrid(elements,x/getfieldvalue(options,'unit',1),y/getfieldvalue(options,'unit',1),...
-	data,xmin,ymax,xspacing,yspacing,nlines,ncols,NaN);
+if radaronly,
+	x_m=xmin:xspacing:xmin+ncols*xspacing;
+	y_m=ymax-nlines*yspacing:yspacing:ymax;
+	data_grid=NaN*ones(nlines,ncols);
+else
+	[x_m y_m data_grid]=InterpFromMeshToGrid(elements,x/getfieldvalue(options,'unit',1),y/getfieldvalue(options,'unit',1),...
+		data,xmin,ymax,xspacing,yspacing,nlines,ncols,NaN);
+end
 
-%Process data_grid
+%Process data_grid (For processing, it is better not to have nan)
 pos=find(isinf(data_grid));
 if ~isempty(pos),
@@ -70,55 +80,57 @@
 end
 data_nan=find(isnan(data_grid));
-
-%Generate HSV image
-contrast=getfieldvalue(options,'contrast',1);  
-transparency=getfieldvalue(options,'alpha',1);
 data_grid(data_nan)=data_min; 
 
+%Special colormaps that require hsv treatment
 colorm=getfieldvalue(options,'colormap','Rignot');
-if strcmpi(colorm,'Rignot'),
-	%hue (H)
-	h_data=(data_grid-data_min)/(data_max-data_min+eps);
-	if radaronly, h_data(:)=0; end
-	%saturation (S)
-	s_data=max(min((0.1+h_data).^(1/transparency),1),0);
-elseif strcmpi(colorm,'Seroussi'),
-	%hue (H)
-	h_data=1-(data_grid-data_min)/(data_max-data_min+eps)*0.7;
-	%h_data=(data_grid-data_min)/(data_max-data_min)*2/3;
-	if radaronly, h_data(:)=0; end
-	%saturation (S)
-	s_data=max(min((0.1+h_data).^(1/transparency),1),0);
-elseif strcmpi(colorm,'redblue')
-	data_mean=data_min+(data_max-data_min)/2;
-	%hue (H)
-	%h_data=0.7*ones(size(data_grid));
-	%h_data(find(data_grid>data_mean))=1;
-	h_data=1*ones(size(data_grid));
-	h_data(find(data_grid<data_mean))=0.7;
-	%saturation (S)
-	s_data=max(min(abs(data_grid-data_mean)/(data_max-data_mean) ,1),0);
+if strcmpi(colorm,'Rignot') | strcmpi(colorm,'Seroussi') | strcmpi(colorm,'redblue')
+	if strcmpi(colorm,'Rignot'),
+		transparency=getfieldvalue(options,'alpha',1);
+		h=(data_grid-data_min)/(data_max-data_min+eps);
+		if radaronly, h(:)=0; end
+		s=max(min((0.1+h).^(1/transparency),1),0);
+	elseif strcmpi(colorm,'Seroussi'),
+		transparency=getfieldvalue(options,'alpha',1);
+		h=1-(data_grid-data_min)/(data_max-data_min+eps)*0.7;
+		if radaronly, h(:)=0; end
+		s=max(min((0.1+h).^(1/transparency),1),0);
+	elseif strcmpi(colorm,'redblue')
+		data_mean=data_min+(data_max-data_min)/2;
+		h=1*ones(size(data_grid));
+		h(find(data_grid<data_mean))=0.7;
+		s=max(min(abs(data_grid-data_mean)/(data_max-data_mean) ,1),0);
+	else
+		error('colormap not supported yet. (''Rignot'' and ''redblue'' are the only cupported colormaps)');
+	end
+	%(S) Saturation is 0 in NaNs
+	s(data_nan)=0;
+	%(V) intensity is based on radar image
+	v=radar; %use radar power as intensity
+
+	%Transform HSV to RGB
+	image_hsv=zeros(size(data_grid,1),size(data_grid,2),3);
+	image_hsv(:,:,1)=h; clear h;
+	image_hsv(:,:,2)=s; clear s;
+	image_hsv(:,:,3)=v; clear v;
+	image_rgb=hsv2rgb(image_hsv);
 else
-	error('colormap not supported yet. (''Rignot'' and ''redblue'' are the only cupported colormaps)');
+	colorm = getcolormap(options);
+	len    = size(colorm,1);
+
+	ind = ceil((len-1)*(data_grid-data_min)/(data_max - data_min + eps) +1);
+	ind(find(ind>len))=len;
+	image_rgb=zeros(size(data_grid,1),size(data_grid,2),3);
+	r=colorm(:,1); image_rgb(:,:,1)=r(ind); clear r;
+	g=colorm(:,2); image_rgb(:,:,2)=g(ind); clear g;
+	b=colorm(:,3); image_rgb(:,:,3)=b(ind); clear b;
+
+	%Now add radarmap
+	r = image_rgb(:,:,1).*radar;  r(data_nan) = radar(data_nan);  image_rgb(:,:,1) = r;  clear r;
+	g = image_rgb(:,:,2).*radar;  g(data_nan) = radar(data_nan);  image_rgb(:,:,2) = g;  clear g;
+	b = image_rgb(:,:,3).*radar;  b(data_nan) = radar(data_nan);  image_rgb(:,:,3) = b;  clear b;
 end
 
-%Saturation is 0 in NaNs
-s_data(data_nan)=0;
-%intensity (V)
-radar=(md.radaroverlay.pwr).^(contrast);
-v_data=radar/max(radar(:)); %use radar power as intensity
-
-%Change background from black to white
-%pos=find(v_data==0);v_data(pos)=1;
-
-%Transform HSV to RGB
-image_hsv=zeros(size(data_grid,1),size(data_grid,2),3);
-image_hsv(:,:,1)=h_data;
-image_hsv(:,:,2)=s_data;
-image_hsv(:,:,3)=v_data;
-image_rgb=hsv2rgb(image_hsv);
-
 %Select plot area 
-subplot(plotlines,plotcols,i);
+subplotmodel(plotlines,plotcols,i,options);
 
 %Plot: 
@@ -134,8 +146,9 @@
 
 %Apply options, without colorbar and without grid
-options=changefieldvalue(options,'colormap',colorm);           %We used an HSV colorbar
+options=changefieldvalue(options,'colormap',colorm);              % We used an HSV colorbar
 if ~isnan(data_min),
-	options=changefieldvalue(options,'caxis',[data_min data_max]); %force caxis so that the colorbar is ready
+	options=changefieldvalue(options,'caxis',[data_min data_max]); % force caxis so that the colorbar is ready
 end
-options=addfielddefault(options,'axis','equal off');           %default axis
+options=addfielddefault(options,'axis','equal off');              % default axis
 applyoptions(md,data,options);
+drawnow
Index: issm/branches/trunk-jpl-damage/src/m/model/plot/plot_profile.m
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/model/plot/plot_profile.m	(revision 12878)
+++ issm/branches/trunk-jpl-damage/src/m/model/plot/plot_profile.m	(revision 12878)
@@ -0,0 +1,55 @@
+function plot_profile(md,data,options,nlines,ncols,ii)
+%PLOT_SECTION - plot a given field on a profile
+%
+%   Usage:
+%      plot_profile(md,data,options,nlines,ncols,i)
+%
+%   See also: PLOTMODEL
+
+%process model
+[x_m y_m z_m elements_m is2d isplanet]=processmesh(md,[],options);
+if is2d, error('only 3d model supported'); end
+
+%Get number of curves and generate random colors
+numcurves=size(data,2);
+colorm=getfieldvalue(options,'colormap','lines');
+color=eval([ colorm '(numcurves);']);
+options=removefield(options,'colormap',0); %back to default colormap
+
+%Get coordinates
+location=getfieldvalue(options,'profile');
+if ~isnumeric(location) | numel(location)~=2,
+	error('location provided not supported (should be [x y])');
+end
+xprof=location(1);
+yprof=location(2);
+
+%Loop over number of curves
+for i=1:numcurves,
+
+	%Process data
+	[datai datatype]=processdata(md,data(:,i),options);
+
+	%resolution
+	if exist(options,'resolution'),
+		resolution=getfieldvalue(options,'resolution');
+	else %Default resolution
+		resolution=[100];
+		disp(['plot_profile warning: no resolution specified, using default: ' num2str(resolution) ]);
+	end
+
+	%Compute profile value
+	[z,data_interp]=ProfileValues(md,datai,xprof,yprof,resolution);
+
+	%plot profile
+	subplot(nlines,ncols,ii)
+	plot(data_interp,z,'color',color(i,:),'LineWidth',getfieldvalue(options,'linewidth',1),'LineStyle','-');
+	hold on;
+end
+
+%apply options
+options=addfielddefault(options,'title','Profile');
+options=addfielddefault(options,'colorbar',0);
+options=addfielddefault(options,'ylabel','z');
+options=addfielddefault(options,'view',2);
+applyoptions(md,[],options);
Index: issm/branches/trunk-jpl-damage/src/m/model/plot/plotdoc.m
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/model/plot/plotdoc.m	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/m/model/plot/plotdoc.m	(revision 12878)
@@ -94,4 +94,5 @@
 disp('       ''showsection'': show section used by ''sectionvalue'' (string ''on'' or a number of labels)');
 disp('       ''sectionvalue'': give the value of data on a profile given by an Argus file (string ''Argusfile_name.exp'')');
+disp('       ''profile'': give the value of data along a vertical profile ([xlocation ylocation])');
 disp('       ''smooth'': smooth element data (string ''yes'' or integer)');
 disp('       ''title'': same as standard matlab option');
Index: issm/branches/trunk-jpl-damage/src/m/model/plot/plotmodel.m
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/model/plot/plotmodel.m	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/m/model/plot/plotmodel.m	(revision 12878)
@@ -48,5 +48,4 @@
 		for i=1:numberofplots,
 			plot_manager(getfieldvalue(options.list{i},'model',md),options.list{i},subplotwidth,nlines,ncols,i);
-			%cbfreeze;
 		end
 	catch me,
Index: issm/branches/trunk-jpl-damage/src/m/model/plot/subplotmodel.m
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/model/plot/subplotmodel.m	(revision 12878)
+++ issm/branches/trunk-jpl-damage/src/m/model/plot/subplotmodel.m	(revision 12878)
@@ -0,0 +1,35 @@
+function ha=subplotmodel(nlines,ncols,num,options);
+%SUBPLOTMODEL -  tight subplot that includes margins
+%
+%   Usage:
+%      h=subplotmodel(nlines,ncols,i,options)
+
+%Regular subplot
+if ~exist(options,'tightsubplot')
+	subplot(nlines,ncols,num);
+	return;
+end
+
+gap     = getfieldvalue(options,'gap',[.01 .01]);
+hmargin = getfieldvalue(options,'hmargin',[.01 .01]);
+vmargin = getfieldvalue(options,'vmargin',[.01 .01]);
+
+height = (1-sum(vmargin)-(nlines-1)*gap(1))/nlines; 
+width  = (1-sum(hmargin)-(ncols-1)*gap(2))/ncols;
+ymin   = 1-vmargin(2)-height; 
+
+for i = 1:nlines
+	xmin = hmargin(1);
+	for j = 1:ncols
+		if(((i-1)*ncols+j)==num)
+			ha = axes('Units','normalized', ...
+				'Position',[xmin ymin width height],'XTickLabel','','YTickLabel','','Visible','off');
+			return
+		end
+		xmin = xmin+width+gap(2);
+	end
+	ymin = ymin-height-gap(1);
+end
+
+%Activate new axes
+axes(ha);
Index: issm/branches/trunk-jpl-damage/src/m/model/process_solve_options.py
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/model/process_solve_options.py	(revision 12878)
+++ issm/branches/trunk-jpl-damage/src/m/model/process_solve_options.py	(revision 12878)
@@ -0,0 +1,47 @@
+import os
+
+def process_solve_options(options):
+	"""
+	DEFAULT_SOLVE_OPTIONS - set up default options for solve phase
+ 
+	    Usage:
+	       options=process_solve_options(options)
+ 
+	    See also: SOLVE
+	"""
+
+	outoptions={}
+
+	#solution_type: check on this option, error out otherwise
+	solution_type=options.getfieldvalue('solution_type')
+	if solution_type in (DiagnosticSolutionEnum,PrognosticSolutionEnum,ThermalSolutionEnum,\
+			SteadystateSolutionEnum,TransientSolutionEnum,EnthalpySolutionEnum,\
+			BalancethicknessSolutionEnum,BedSlopeSolutionEnum,SurfaceSlopeSolutionEnum,HydrologySolutionEnum,FlaimSolutionEnum):
+		raise ValueError("process_solve_options error message: solution_type '%s' not supported yet!" % EnumToString(solution_type))
+	outoptions['solution_type']=solution_type
+
+	outoptions['upload']=options.getfieldvalue('upload','off')
+	outoptions['batch']=options.getfieldvalue('batch','no')
+	outoptions['loadonly']=options.getfieldvalue('loadonly',False)
+	outoptions['directory']=options.getfieldvalue('directory','')
+
+	#  process qmu arguments
+	outoptions['qmudir']=options.getfieldvalue('qmudir','qmu'+str(os.getpid()))
+	outoptions['qmufile']=options.getfieldvalue('qmufile','qmu')    # qmufile cannot be changed unless ????script.sh is also changed
+	outoptions['overwrite']=options.getfieldvalue('overwrite','n')
+	outoptions['keep']=options.getfieldvalue('keep','n')
+	outoptions['ivar']=options.getfieldvalue('ivar',1)
+	outoptions['iresp']=options.getfieldvalue('iresp',1)
+	outoptions['imethod']=options.getfieldvalue('imethod',1)
+	outoptions['iparams']=options.getfieldvalue('iparams',1)
+	outoptions['runmpi']=options.getfieldvalue('runmpi',False)
+
+	#  process flaim arguments
+	outoptions['fmdir']=options.getfieldvalue('fmdir','fm'+str(os.getpid()))
+	outoptions['overwrite']=options.getfieldvalue('overwrite','n')
+	outoptions['keep']=options.getfieldvalue('keep','y')
+	outoptions['latsgn']=options.getfieldvalue('latsgn',0)
+	outoptions['cmap']=options.getfieldvalue('cmap',None)
+
+	return outoptions
+
Index: issm/branches/trunk-jpl-damage/src/m/model/radarpower.m
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/model/radarpower.m	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/m/model/radarpower.m	(revision 12878)
@@ -37,11 +37,14 @@
 			error(['radarpower error message: file ' jplsvn() '/projects/ModelData/MOG/mog150_greenland_map.jpg not found.']);
 		end
-		jpgim=[jplsvn() '/projects/ModelData/MOG/mog150_greenland_map.jpg'];
-		geom=load([jplsvn() '/projects/ModelData/MOG/mog150_greenland_map.jpgw'],'ascii');
+		name = 'mog150_greenland_map';
+		%name = 'mog100_hp1_v10';
+		%name = 'mog500_hp1_v10';
+		jpgim=[jplsvn() '/projects/ModelData/MOG/' name '.jpg'];
+		geom=load([jplsvn() '/projects/ModelData/MOG/' name '.jpgw'],'ascii');
 
 		%geom:   xposting nbcols nbrows yposting xmin ymax
 		xmin=max(geom(5),x0);
 		xmax=min(geom(5)+geom(1)*geom(2),x1);
-		ymin=max(geom(6)-geom(4)*geom(3),y0);
+		ymin=max(geom(6)-geom(3)*geom(4),y0);
 		ymax=min(geom(6),y1);
 
@@ -106,5 +109,4 @@
 	toplefty=floor((overlay_ylim(2)-y1)/overlay_yposting); % y max
 
-
 	%Read and crop file
 	disp('Warning: expecting coordinates in polar stereographic (Std Latitude: 70ºN Meridian: 45º)');
Index: issm/branches/trunk-jpl-damage/src/m/model/regionaltransient2d.m
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/model/regionaltransient2d.m	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/m/model/regionaltransient2d.m	(revision 12878)
@@ -106,5 +106,5 @@
 			thickness=PatchToVec(md1.results.TransientSolution(t).Thickness);
 			spcx=[spcx InterpFromMeshToMesh2d(md1.mesh.elements,md1.mesh.x,md1.mesh.y,vx,md2.mesh.x,md2.mesh.y)];
-			spcy=[spcy InterpFromMeshToMesh2d(md1.mesh.elements,md1.mesh.x,md1.mesh.y,vx,md2.mesh.x,md2.mesh.y)];
+			spcy=[spcy InterpFromMeshToMesh2d(md1.mesh.elements,md1.mesh.x,md1.mesh.y,vy,md2.mesh.x,md2.mesh.y)];
 			spct=[spct InterpFromMeshToMesh2d(md1.mesh.elements,md1.mesh.x,md1.mesh.y,thickness,md2.mesh.x,md2.mesh.y)];
 			steps=[steps t*md1.timestepping.time_step];
Index: issm/branches/trunk-jpl-damage/src/m/model/setmask.m
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/model/setmask.m	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/m/model/setmask.m	(revision 12878)
@@ -25,5 +25,5 @@
 elements=md.mesh.elements;
 
-%Assign elementonfloatingice, elementongroundedice, vertexongroundedice and vertexonfloatingice. Only change at your own peril! This is synchronized heavily with the GroundingLineMigration module. {{{1
+%Assign elementonfloatingice, elementongroundedice, vertexongroundedice and vertexonfloatingice. Only change at your own peril! This is synchronized heavily with the GroundingLineMigration module. {{{
 elementonfloatingice=FlagElements(md,floatingicename);
 elementongroundedice=FlagElements(md,groundedicename);
Index: issm/branches/trunk-jpl-damage/src/m/model/setmask.py
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/model/setmask.py	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/m/model/setmask.py	(revision 12878)
@@ -22,5 +22,5 @@
 	elements = md.mesh.elements
 
-	#Assign elementonfloatingice, elementongroundedice, vertexongroundedice and vertexonfloatingice. Only change at your own peril! This is synchronized heavily with the GroundingLineMigration module. {{{1
+	#Assign elementonfloatingice, elementongroundedice, vertexongroundedice and vertexonfloatingice. Only change at your own peril! This is synchronized heavily with the GroundingLineMigration module. {{{
 	elementonfloatingice = fe.FlagElements(md, floatingicename)
 	elementongroundedice = fe.FlagElements(md, groundedicename) 
Index: issm/branches/trunk-jpl-damage/src/m/model/solve.m
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/model/solve.m	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/m/model/solve.m	(revision 12878)
@@ -24,21 +24,20 @@
 %      md=solve(md,DiagnosticSolutionEnum);
 
-%recover options
+%recover and process solve options
 options=pairoptions(varargin{:},'solution_type',solutionenum);
-
-%add default options
 options=process_solve_options(options);
 
 %recover some fields
 md.private.solution=options.solution_type;
+cluster=md.cluster;
 
 %check model consistency
 disp('checking model consistency');
 if (solutionenum == FlaimSolutionEnum)
-	modelconsistency(true);
-	md.mesh.checkconsistency(md,solutionenum);
-	md.flaim.checkconsistency(md,solutionenum);
-	if ~modelconsistency()
-		error(' ');
+	md.private.isconsistent=true;
+	md=checkconsistency(md.mesh,md,solutionenum);
+	md=checkconsistency(md.flaim,md,solutionenum);
+	if md.private.isconsistent==false,
+		error('Model not consistent, see messages above');
 	end
 else
@@ -46,15 +45,16 @@
 end
 
-%if running qmu analysis, some preprocessing of dakota files using 
-%models fields needs to be carried out. 
+%First, build a runtime name that is unique
+c=clock;
+md.private.runtimename=sprintf('%s-%02i-%02i-%04i-%02i-%02i-%02i-%i',md.miscellaneous.name,c(2),c(3),c(1),c(4),c(5),floor(c(6)),feature('GetPid'));
+
+%if running qmu analysis, some preprocessing of dakota files using models
+%fields needs to be carried out. 
 if md.qmu.isdakota,
 	md=preqmu(md,options);
 end
 
-%Save model as is (in case of a crash)
-assignin('base',inputname(1),md);
-
 %flaim analysis
-if (md.private.solution == FlaimSolutionEnum)
+if (options.solution_type == FlaimSolutionEnum)
 	md=flaim_sol(md,options);
 	md.private.solution=EnumToString(options.solution_type);
@@ -62,29 +62,58 @@
 end
 
-%Marshall model data into a binary file.
-marshall(md);
-
-%write a template file for issm to use, in parallel
-PetscFile(md.solver,[md.miscellaneous.name '.petsc']);
-
-%If running in parallel, we have a different way of launching the solution
-%sequences. 
-if ~strcmpi(md.cluster.name,'none'),
-	md=solveparallel(md,options);
+%Do we load results only?
+if options.loadonly,  
+	md=loadresultsfromcluster(md);
 	return;
 end
 
-%Launch correct solution sequence
-md=issm(md,md.private.solution);
+%Wite all input files
+marshall(md);                                          % bin file
+PetscFile(md.solver,[md.miscellaneous.name '.petsc']); % petsc file
+BuildQueueScript(cluster,md.private.runtimename,md.miscellaneous.name,md.private.solution,md.settings.io_gather,md.debug.valgrind,md.debug.gprof); % queue file
+
+%we need to make sure we have PETSC support, otherwise, we run with only one cpu: 
+if ~ispetsc,
+	disp('PETSC support not included, running on 1 cpu only!');
+	cluster.np=1;
+end
+
+%Stop here if batch mode
+if strcmpi(options.batch,'yes')
+	disp('batch mode requested: not launching job interactively');
+	disp('launch solution sequence on remote cluster by hand');
+	return;
+end
+
+%Launch job
+modelname = md.miscellaneous.name;
+filelist  = {[modelname '.bin '] [modelname '.petsc '] [modelname '.queue ']};
+if md.qmu.isdakota,
+	filelist{end+1} = [modelname '.qmu.in'];
+end
+LaunchQueueJob(cluster,md.miscellaneous.name,md.private.runtimename,filelist);
+
+%did we even try to run? if so, wait on lock
+if strcmpi(options.upload,'on'),
+	disp('solve done uploading test decks');
+	return;
+end
+
+%wait on lock
+if md.settings.waitonlock>0,
+	%we wait for the done file
+	islock=waitonlock(md);
+	if islock==0, %no results to be loaded
+		disp('The results must be loaded manually with md=loadresultsfromcluster(md).');
+	else          %load results
+		disp('loading results from cluster');
+		md=loadresultsfromcluster(md);
+	end
+end
 
 %post processes qmu results if necessary
 if md.qmu.isdakota,
-	md=postqmu(md);
-	cd ..
 	if ~strncmpi(options.keep,'y',1)
 		system(['rm -rf qmu' num2str(feature('GetPid'))]);
 	end
 end
-
-%convert analysis type to string finally
-md.private.solution=EnumToString(options.solution_type);
Index: issm/branches/trunk-jpl-damage/src/m/model/solve.py
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/model/solve.py	(revision 12878)
+++ issm/branches/trunk-jpl-damage/src/m/model/solve.py	(revision 12878)
@@ -0,0 +1,115 @@
+import datetime
+import os
+import shutil
+
+def solve(md,solutionenum,*args):
+	"""
+	SOLVE - apply solution sequence for this model
+ 
+	    Usage:
+	       md=solve(md,solutionenum,varargin)
+	       where varargin is a list of paired arguments of string OR enums
+ 
+	    solution types available comprise:
+	 		 - DiagnosticSolutionEnum
+	 		 - PrognosticSolutionEnum
+	 		 - ThermalSolutionEnum
+	 		 - SteadystateSolutionEnum
+	 		 - TransientSolutionEnum...
+	 		 - BalancethicknessSolutionEnum
+	 		 - BedSlopeSolutionEnum
+	 		 - SurfaceSlopeSolutionEnum
+	 		 - HydrologySolutionEnum
+	 		 - FlaimSolutionEnum
+ 
+	   extra options:
+	       - loadonly : does not solve. only load results
+ 
+	    Examples:
+	       md=solve(md,DiagnosticSolutionEnum);
+	"""
+
+	#recover and process solve options
+	options=pairoptions('solution_type',solutionenum,*args)
+	options=process_solve_options(options)
+
+	#recover some fields
+	md.private.solution=options['solution_type']
+	cluster=md.cluster
+
+	#check model consistency
+	print "checking model consistency"
+	if solutionenum == FlaimSolutionEnum:
+		md.private.isconsistent=True
+		md.mesh.checkconsistency(md,solutionenum)
+		md.flaim.checkconsistency(md,solutionenum)
+		if not md.private.isconsistent:
+			raise RuntimeError("Model not consistent, see messages above.")
+	else:
+		ismodelselfconsistent(md)
+
+	#First, build a runtime name that is unique
+	c=datetime.datetime.now()
+	md.private.runtimename="%s-%02i-%02i-%04i-%02i-%02i-%02i-%i" % (md.miscellaneous.name,c.month,c.day,c.year,c.hour,c.minute,c.second,os.getpid())
+
+	#if running qmu analysis, some preprocessing of dakota files using models
+	#fields needs to be carried out. 
+	if md.qmu.isdakota:
+		md=preqmu(md,options)
+
+	#flaim analysis
+	if options['solution_type'] == FlaimSolutionEnum:
+		md=flaim_sol(md,options)
+		md.private.solution=EnumToString(options['solution_type'])
+		return md
+
+	#Do we load results only?
+	if options['loadonly']:  
+		md=loadresultsfromcluster(md)
+		return md
+
+	#Wite all input files
+	marshall(md)                                           # bin file
+	md.solver.PetscFile(md.miscellaneous.name+'.petsc')    # petsc file
+	cluster.BuildQueueScript(md.miscellaneous.name,md.private.runtimename,md.private.solution,md.settings.io_gather,md.debug.valgrind,md.debug.gprof)    # queue file
+
+	#we need to make sure we have PETSC support, otherwise, we run with only one cpu: 
+	if not ispetsc:
+		print "PETSC support not included, running on 1 cpu only!"
+		cluster.np=1
+
+	#Stop here if batch mode
+	if strcmpi(options['batch'],'yes'):
+		print 'batch mode requested: not launching job interactively'
+		print 'launch solution sequence on remote cluster by hand'
+		return md
+
+	#Launch job
+	modelname = md.miscellaneous.name
+	filelist  = [modelname+'.bin ',modelname+'.petsc ',modelname+'.queue ']
+	if md.qmu.isdakota:
+		filelist.append(modelname+'.qmu.in')
+	cluster.LaunchQueueJob(md.miscellaneous.name,md.private.runtimename,filelist)
+
+	#did we even try to run? if so, wait on lock
+	if strcmpi(options['upload'],'on'):
+		print 'solve done uploading test decks'
+		return md
+
+	#wait on lock
+	if md.settings.waitonlock>0:
+		#we wait for the done file
+		islock=waitonlock(md)
+		if islock==0:    #no results to be loaded
+			print 'The results must be loaded manually with md=loadresultsfromcluster(md).'
+		else:            #load results
+			print 'loading results from cluster'
+			md=loadresultsfromcluster(md)
+
+	#post processes qmu results if necessary
+	if md.qmu.isdakota:
+		if not strncmpi(options['keep'],'y',1):
+			shutil.rmtree('qmu'+str(os.getpid()))
+
+	return md
+
Index: issm/branches/trunk-jpl-damage/src/m/model/solvers/stokesoptions.m
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/model/solvers/stokesoptions.m	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/m/model/solvers/stokesoptions.m	(revision 12878)
@@ -6,5 +6,5 @@
 
 %retrieve options provided in varargin
-arguments=pairoptions(varargin{:});
+options=pairoptions(varargin{:});
 stokes=struct();
 
Index: issm/branches/trunk-jpl-damage/src/m/model/waitonlock.py
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/model/waitonlock.py	(revision 12878)
+++ issm/branches/trunk-jpl-damage/src/m/model/waitonlock.py	(revision 12878)
@@ -0,0 +1,64 @@
+import os
+import socket
+import time
+from MatlabFuncs import *
+
+def waitonlock(md,executionpath,login,port):
+	"""
+	WAITONLOCK - wait for a file
+ 
+	    This routine will return when a file named 'filename' is written to disk.
+	    If the time limit given in input is exceeded, return 0
+ 
+	    Usage:
+	       flag=waitonlock(md,executionpath)
+	"""
+
+	#Get filename (lock file) and options
+	executionpath=md.cluster.executionpath
+	cluster=md.cluster.name
+	login=md.cluster.login
+	port=md.cluster.port
+	timelimit=md.settings.waitonlock
+	filename=os.path.join(executionpath,md.private.runtimename,md.miscellaneous.name+'.lock')
+
+	#waitonlock will work if the lock is on the same machine only: 
+	if not strcmpi(socket.gethostname().lower().split('.')[0],cluster):
+
+		print 'solution launched on remote cluster. log in to detect job completion.'
+		choice=raw_input('Is the job successfully completed? (y/n) ')
+		if not strcmp(choice,'y'): 
+			print 'Results not loaded... exiting' 
+			flag=0
+		else:
+			flag=1
+
+	#job is running on the same machine
+	else:
+
+		if 'interactive' in vars(md.cluster) and md.cluster.interactive:
+			#We are in interactive mode, no need to check for job completion
+			flag=1
+			return flag
+		#initialize time and file presence test flag
+		etime=0
+		ispresent=0
+		print "waiting for '%s' hold on... (Ctrl+C to exit)" % filename
+
+		#loop till file .lock exist or time is up
+		while ispresent==0 and etime<timelimit:
+			ispresent=os.path.exist(filename)
+			time.sleep(1)
+			etime+=1/60
+
+		#build output
+		if etime>timelimit:
+			print 'Time limit exceeded. Increase md.settings.waitonlock'
+			print 'The results must be loaded manually with md=loadresultsfromcluster(md).'
+			raise RuntimeError('waitonlock error message: time limit exceeded.')
+			flag=0
+		else:
+			flag=1
+
+	return flag
+
Index: issm/branches/trunk-jpl-damage/src/m/qmu/preqmu.m
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/qmu/preqmu.m	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/m/qmu/preqmu.m	(revision 12878)
@@ -44,5 +44,5 @@
 responses=expandresponses(md,responses);
 
-%go through variables and responses, and check they don't have more than md.qmu.numberofpartitions values. Also determine numvariables and numresponses{{{1
+%go through variables and responses, and check they don't have more than md.qmu.numberofpartitions values. Also determine numvariables and numresponses{{{
 numvariables=0;
 variable_fieldnames=fieldnames(variables);
@@ -76,5 +76,5 @@
 system(['rm -rf ' md.miscellaneous.name '.m']);
 
-%build a list of variables and responses descriptors. the list is not expanded. {{{1
+%build a list of variables and responses descriptors. the list is not expanded. {{{
 variabledescriptors={};
 variable_fieldnames=fieldnames(md.qmu.variables(options.ivar));
